//***************************************************************************
//
//                          LPH9116 (LPH8731)    
//
//***************************************************************************
#ifndef	LPH87313C_h
#define	LPH87313C_h        

#include "Symbols.h"
#include <delay.h>
#include <string.h>

//===============================================================
//                     
//===============================================================
#define GREEN       0x1C
#define DARK_GREEN  0x15
#define RED         0xE0
#define CYAN        0x1F    
#define BLUE        0x03
#define YELLOW      0xFC
#define ORANGE      0xEC
#define VIOLET      0xE3
#define WHITE       0xFF
#define BLACK       0x00
#define GREY        0x6D


//*************************************************************
//   
#define LCD_CS 		PORTB.0 // 
#define LCD_RESET 	PORTB.1 //
#define LCD_RS 		PORTB.2	//CD -   
#define LCD_CLK 	PORTB.3 //
#define LCD_DATA 	PORTB.4 //

//*************************************************************
///
#define CMD 	0
#define DAT 	1
char RS_old;

//*************************************************************
unsigned char com_row=0, com_column=0; //    "" (   ),         

//*************************************************************
//
void LCD_init ();
void Send_to_lcd (unsigned char RS, unsigned char data);
void SetArea (char x1, char x2, char y1, char y2);
void Put_Pixel (char x, char y, unsigned int color);
void Send_Symbol (unsigned char symbol, char row, char column, int t_color, int b_color);
void LCD_Putsf (flash unsigned char *str, char row, char column, int t_color, int b_color);  
void LCD_Puts (unsigned char *str, char row, char column, char *t_color, int b_color);
void LCD_FillScreen (unsigned int color);
void LCD_FillRect (char x1, char y1, char width, char height, int color);

//===============================================================
//                        
//===============================================================
void LCD_init ()
{
 LCD_CS = 0;
 LCD_DATA = 0;
 LCD_RESET=0;
 delay_ms(100);
 LCD_RESET=1;
 delay_ms(500); 
 LCD_CS = 1;
 delay_us(5);
 LCD_CS = 0;
 Send_to_lcd(CMD,0x01); //reset sw
 delay_ms(50);
 Send_to_lcd(CMD,0xc6); //initial escape
 delay_ms(40);
 Send_to_lcd(CMD,0xb9); //Refresh set
 Send_to_lcd(DAT,0x00);
 Send_to_lcd(CMD,0xb6); //Display control
 Send_to_lcd(DAT,0x80); 
 Send_to_lcd(DAT,0x04); 
 Send_to_lcd(DAT,0x8a);
 Send_to_lcd(DAT,0x54); 
 Send_to_lcd(DAT,0x45); 
 Send_to_lcd(DAT,0x52); 
 Send_to_lcd(DAT,0x43); 
 Send_to_lcd(CMD,0xb3); //Gray scale position set 0
 Send_to_lcd(DAT,0x02); 
 Send_to_lcd(DAT,0x0a); 
 Send_to_lcd(DAT,0x15); 
 Send_to_lcd(DAT,0x1f); 
 Send_to_lcd(DAT,0x28); 
 Send_to_lcd(DAT,0x30); 
 Send_to_lcd(DAT,0x37); 
 Send_to_lcd(DAT,0x3f); 
 Send_to_lcd(DAT,0x47); 
 Send_to_lcd(DAT,0x4c); 
 Send_to_lcd(DAT,0x54); 
 Send_to_lcd(DAT,0x65); 
 Send_to_lcd(DAT,0x75); 
 Send_to_lcd(DAT,0x80); 
 Send_to_lcd(DAT,0x85); 
 Send_to_lcd(CMD,0xb5); //Gamma curve
 Send_to_lcd(DAT,0x01); 
 Send_to_lcd(CMD,0xb7); //Temperature gradient
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00);
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(CMD,0xbd); //Common driver output select
 Send_to_lcd(DAT,0x00);   
 Send_to_lcd(CMD,0x36); //Memory access control -      (     ,     ) 
 Send_to_lcd(DAT,0x48); 
 Send_to_lcd(CMD,0x2d); //Colour set
 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x03); 
 Send_to_lcd(DAT,0x05); 
 Send_to_lcd(DAT,0x07); 
 Send_to_lcd(DAT,0x09); 
 Send_to_lcd(DAT,0x0b); 
 Send_to_lcd(DAT,0x0d); 
 Send_to_lcd(DAT,0x0f); 

 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x03); 
 Send_to_lcd(DAT,0x05); 
 Send_to_lcd(DAT,0x07); 
 Send_to_lcd(DAT,0x09); 
 Send_to_lcd(DAT,0x0b); 
 Send_to_lcd(DAT,0x0d); 
 Send_to_lcd(DAT,0x0f); 

 Send_to_lcd(DAT,0x00); 
 Send_to_lcd(DAT,0x05); 
 Send_to_lcd(DAT,0x0b); 
 Send_to_lcd(DAT,0x0f); 
 Send_to_lcd(CMD,0xba); //Voltage control
 Send_to_lcd(DAT,0x2f); 
 Send_to_lcd(DAT,0x03); 
 Send_to_lcd(CMD,0x25); //Send_to_lcd contrast  
 Send_to_lcd(DAT,0x61); 
 Send_to_lcd(CMD,0xbe); //Power control
 Send_to_lcd(DAT,0x58);  

 Send_to_lcd(CMD,0x3a); //   
 Send_to_lcd(DAT,0x02); //8-  
 Send_to_lcd(CMD,0x03); //Booster voltage ON
 delay_ms(40);
 Send_to_lcd(CMD,0x11); //   

 delay_ms(20); //   20  
 Send_to_lcd(CMD,0x29); //       
}

//===============================================================
//  /  LCD (RS==0 - , RS==1 - )
//===============================================================
void Send_to_lcd (unsigned char RS, unsigned char data)
{
 //unsigned char count;  
 LCD_CLK = 0;
 LCD_DATA = 0;
 if ((RS_old != RS) || (!RS_old && !RS)) //   RS (      CS)
 { 
  LCD_CS=1;	//  CS 
  LCD_RS=RS;	
  LCD_CS=0;	//  CS 
 }           

 LCD_DATA = 0;
 if ((data & 128) == 128)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 64) == 64)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 32) == 32)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 16) ==16)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 8) == 8)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 4) == 4)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 2) == 2)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 LCD_DATA = 0;
 if ((data & 1) == 1)  LCD_DATA = 1; 
 LCD_CLK=1;
 LCD_CLK=0;
 
 RS_old=RS;  //  RS	
 LCD_DATA = 0;    
}

//===============================================================
//                 
//===============================================================
void SetArea(char x1, char x2, char y1, char y2)
{
 Send_to_lcd( CMD, 0x2A );  //   X
 Send_to_lcd( DAT, x1 );    //
 Send_to_lcd( DAT, x2 );    //

 Send_to_lcd( CMD, 0x2B );  //   Y
 Send_to_lcd( DAT, y1+1 );  // (   Y   1,    0)
 Send_to_lcd( DAT, y2+1 );  //

 Send_to_lcd( CMD, 0x2C );  //          
}
             
//===============================================================
//     (8-    (256 ))
//=============================================================== 
void Put_Pixel (char x, char y, unsigned int color) 
{
 SetArea( x, x, y, y );     
 Send_to_lcd( DAT, color ); // -    
}  
                   
//===============================================================
//     ASCII- (  Symbols.h)
//===============================================================
//    10  (row)  16  (column)
void Send_Symbol (unsigned char symbol, char row, char column, int t_color, int b_color) 
{  
 unsigned char temp_symbol, x, y;    
 column = (column*6)+2;   //  (  )   x ( 101 )    ; "+2" -    2 
 row = row*8;         //  (  )   y ( 80 )    
 if (symbol>129) symbol-=62;    //    ASCII
 //   - -      
 for (x = 0; x < 5; x++) //  5-  (5 ),   58 
 {
  SetArea(column + x, column + x, row, row+7);  //     ()  5-,   
  temp_symbol = array_simbols[symbol-32] [x];  //    5-,      
  for (y = 0; y < 8; y++)  //  8  
  {  
   if (temp_symbol&1)   Send_to_lcd( DAT, t_color ); // 
   else                 Send_to_lcd( DAT, b_color ); //  
   temp_symbol >>= 1;
  }
 } 
}

//===============================================================
//           ,   flash
//===============================================================    
//      ,     row  column , 
//    com_row  com_column.     ,   
//   .     10  (row)  16  (column)
void LCD_Putsf (flash unsigned char *str, char row, char column, int t_color, int b_color)
{   
 while (*str)  //   
 {
  if((*str!='\n')&&(*str!='\r'))
  {
   Send_Symbol (*str++, row, column, t_color, b_color);
   //  ,     
   column++;
   if(column==16) 
   {
    column=0;
    row++;
   }
  }
  else {
        if(*str=='\n') //  
        {
         if(++row==10) row=0;
        }
        if(*str=='\r')  column=0;  //  
        str++;       
       }         
 }    
 //       (      )
 com_row=row;          
 com_column=column;
}

//===============================================================
//            ,   ram  
//=============================================================== 
void LCD_Puts (unsigned char *str, char row, char column, char *t_color, int b_color)
{  
 while (*str)  //       
 {
  if((*str!='\n')&&(*str!='\r'))
  {
   Send_Symbol (*str++, row, column, *t_color++, b_color);
   //  ,     
   column++;
   if(column==16) 
   {
    column=0;
    row++;
   }
  }
  else {
        if(*str=='\n') //  
        {
         if(++row==10) row=0;
        }
        if(*str=='\r')  column=0;  //  
        str++;       
       }         
 }    
 //       (      )
 com_row=row;          
 com_column=column;
}

//===============================================================
//                     
//===============================================================
void LCD_FillScreen (unsigned int color)
{ 
 unsigned int x;
 SetArea( 0, 100, 0, 80 );   //  
 for (x = 0; x < 8080; x++)  
 {   
  Send_to_lcd( DAT, color ); // -    
 }                 
} 
 
//===============================================================
//                 COLOR
//===============================================================
void LCD_FillRect (char x1, char y1, char width, char height, int color)
{
 unsigned int x;
       
 SetArea( x1, x1+(width-1), y1, y1+(height-1) );  
 for (x = 0; x < width * height; x++) 
 {   
  Send_to_lcd( DAT, color ); // -      
 }   
}  

#endif 

